// ************************************************
// Shopping Cart API
// ************************************************

var shoppingCart = (function() {
  // =============================
  // Private methods and propeties
  // =============================
  cart = [];
  
  // Constructor
 function Item(name, price, count, id, file_url) {
    this.name = name;
    this.price = price;
    this.count = count;
    this.id = id;
    this.file_url = file_url;
  }
  
  // Save cart
  function saveCart() {
    sessionStorage.setItem('shoppingCart', JSON.stringify(cart));
  }
  
    // Load cart
  function loadCart() {
    cart = JSON.parse(sessionStorage.getItem('shoppingCart'));
  }
  if (sessionStorage.getItem("shoppingCart") != null) {
    loadCart();
  }
  

  // =============================
  // Public methods and propeties
  // =============================
  var obj = {};
  
  // Add to cart
  // Add to cart
  obj.addItemToCart = function(name, price, count, id, file_url) {
    for(var item in cart) {
      if(cart[item].name === name) {
        cart[item].count ++;
        saveCart();
        return;
      }
    }
    var item = new Item(name, price, count, id, file_url);
    cart.push(item);
    saveCart();
  }
  
  // Set count from item
  obj.setCountForItem = function(name, count) {
    for(var i in cart) {
      if (cart[i].name === name) {
        cart[i].count = count;
        break;
      }
    }
  };
  // Remove item from cart
  obj.removeItemFromCart = function(name) {
      for(var item in cart) {
        if(cart[item].name === name) {
          cart[item].count --;
          if(cart[item].count === 0) {
            cart.splice(item, 1);
          }
          break;
        }
    }
    saveCart();
  }

  // Remove all items from cart
  obj.removeItemFromCartAll = function(name) {
    for(var item in cart) {
      if(cart[item].name === name) {
        cart.splice(item, 1);
        break;
      }
    }
    saveCart();
  }

  // Clear cart
  obj.clearCart = function() {
    cart = [];
    saveCart();
  }

  // Count cart 
  obj.totalCount = function() {
    var totalCount = 0;
    for(var item in cart) {
      totalCount += cart[item].count;
    }
    return totalCount;
  }

  // Total cart
  obj.totalCart = function() {
    var totalCart = 0;
    for(var item in cart) {
      totalCart += cart[item].price * cart[item].count;
    }
    return Number(totalCart.toFixed(2));
  }

  // List cart
  obj.listCart = function() {
    var cartCopy = [];
    for(i in cart) {
      item = cart[i];
      itemCopy = {};
      for(p in item) {
        itemCopy[p] = item[p];

      }
      itemCopy.total = Number(item.price * item.count).toFixed(2);
      cartCopy.push(itemCopy)
    }
    return cartCopy;
  }

  // cart : Array
  // Item : Object/Class
  // addItemToCart : Function
  // removeItemFromCart : Function
  // removeItemFromCartAll : Function
  // clearCart : Function
  // countCart : Function
  // totalCart : Function
  // listCart : Function
  // saveCart : Function
  // loadCart : Function
  return obj;
})();


// *****************************************
// Triggers / Events
// ***************************************** 
// Add item

 $(document).on('click','#add_2_cart',function (event){

 //alert('You can only buy two songs at a time.'); cart-count0
 
  event.preventDefault();
    var name = $(this).data('name');
    var price = Number($(this).data('price'));
    var id = ($(this).data('id'));
    var file_url = ($(this).data('file_url'));
    var prodctimgurl = ($(this).data('prodct_img_url'));

  // var count = $(this).closest(".products_array").find("#p-items").val();
	// alert(file_url);
	// alert(prodctimgurl);
  shoppingCart.addItemToCart(name, price, 1, id,file_url);
  displayCart();
  $('#cart').fadeIn('slow'); 
  
  
});

// Clear items
$('.clear-cart').click(function() {
  shoppingCart.clearCart();
  displayCart();
});

// Clear items
$('#close-cart-btn').click(function() {
  shoppingCart.clearCart();
  displayCart();
});


function displayCart() {
  var cartArray = shoppingCart.listCart();
  var output = "";
  for(var i in cartArray) {
    output += "<tr>"
     + "<td class='w3-hide-small'>" + cartArray[i].id + "</td>" 
      + "<td style='color:rgba(1,68,1,255);font-weight:600;font-size:1.2em;'>" + cartArray[i].name + "</td>" 
      + "<td style='color:rgba(1,68,1,255);font-weight:600;font-size:1.2em;'>K" + cartArray[i].price + "</td>"
      + "<td class='w3-hide-small'><div class='input-group'>"
      + "Units: <input type='number' class='item-count form-control' data-name='" + cartArray[i].name + "' value='" + cartArray[i].count + "' style='width:60px;border:none;'>"
     + "</div></td>"
     + " = " 
     + "<td class='w3-hide-small'>" + cartArray[i].total + "</td>" 
	 + "<td style='display:none;'><span class='delete-item fontx fx-trash-2' data-name=" + cartArray[i].name + "></span></td>"
      
      + "</tr>";
	 //alert(cartArray[i].id); 
	 //alert(cartArray); 

	  
  }
  
  	// var json = JSON.stringify(cartArray);
    // alert(json);
	 
  $('.show-cart').html(output);
  $('.total-cart').html(shoppingCart.totalCart());
  $('.total-count').html(shoppingCart.totalCount());
  
   //alert(output);
  
    
}

// Delete item button

$(document).on("click", ".delete-item", function(event) {
	//alert('Hello');
  var name = $(this).data('name');
  shoppingCart.removeItemFromCartAll(name);
  displayCart();
})


// Item count input

$('.show-cart').on("keyup", ".item-count", function(event) {
   var name = $(this).data('name');
   var count = Number($(this).val());
  shoppingCart.setCountForItem(name, count);
  displayCart();
});

$('.show-cart').on("change", ".item-count", function(event) {
   var name = $(this).data('name');
   var count = Number($(this).val());
  shoppingCart.setCountForItem(name, count);
  displayCart();
});


displayCart();

var orderDetails = JSON.stringify(cart);
    
     //alert(cart2);
	 

$(document).on('click', '#mobilePayBtn', function(event){
		event.preventDefault();
		event.stopPropagation();
		
		 // alert(orderDetails);
		 var phone = $('#phone').val();
		 $('#phone-number00').empty();
		 $('#phone-number00').append(phone);
		 var amount = $('.total-cart').html();
		 var userid = '001';
		 var fname = 'Ngenda';
		 var lname = 'Muliwana';
		 var email = 'ngendamuliwana@gmail.com';
		 
		  //tract_url = JSON.parse(orderDetails);
		  //alert(tract_url);
		  //isEmpty(tract_url)
		  
		 var cartlist = shoppingCart.listCart();
		 var cartlistDetails = JSON.stringify(cartlist);
        // alert(cartlistDetails);

		if(phone != '' && cartlistDetails != '')
		{
			 
		   datastring='userid='+userid+'&phone='+phone+'&fname='+fname+'&lname='+lname+'&email='+email+'&orderDetails='+cartlistDetails+'&amount='+amount;
		
              
	    $.ajax({
				 					
	        data:datastring,
			url: "payment-processing/mobileMoneyPayment.php",
	        type: "POST"	
				
	    }).done (function(data) {
			  
  
			 // alert(data);
			 var newdata = JSON.parse(data);
			// alert(newdata);
			 
			 $("#donate_main_container01").empty();
			 $("#donate_main_container01").append('<h4>Processing payment...</h4>');
			  
			 $("#donate_main_container01").append('<div class="payment-loader"></div><br/>');
		 
		    setTimeout(function(){ 
			
			 $("#donate_main_container01").empty();
			  $("#donate_main_container01").append('<h4 class="w3-animate-fading">Please wait!</h4>');
			  
			 $("#donate_main_container01").append('<div class="payment-loader"></div><br/>');
		     $("#donate_main_container01").append('<h5 class="w3-animate-fading" style="color:rgb(0, 153, 204);">Sending prompt to client!</h5>');
			 
			 
			}, 10000);
		 
			 $('#reference_id01').empty();
			$('#reference_id01').append('<span style="font-weight:600;">Transaction Reference is: </span><div id="transactioReferenceStorage01"></div>');
			 
			 $('#transactioReferenceStorage01').empty();
			 $('#transactioReferenceStorage01').append(newdata.transactionReference);
			 //var reference = ;
			 
			 
			  setInterval(function(){
                
                      var tref = $('#transactioReferenceStorage01').html();
		
                   if(tref != ''){
					 
						datastring='tref='+tref;

						$.ajax({

						data:datastring,
						url: "payment-processing/verifyPayment.php",
						type: "POST"	

						}).done (function(data) {

						 var newdata = JSON.parse(data);
						 
						  //alert(data);
                          // alert(newdata.transaction_status);
						  
							$.each(newdata.details, function(i,freelance) {
 
                            if(freelance.transaction_status == 'approved'){
						
						     // alert('Payment Approved');
						    $("#modal_icon01").empty();
							$("#modal_icon01").append('<svg class="heart" viewBox="0 0 32 29.6"><path d="M23.6,0c-3.4,0-6.3,2.7-7.6,5.6C14.7,2.7,11.8,0,8.4,0C3.8,0,0,3.8,0,8.4c0,9.4,9.5,11.9,16,21.2c6.1-9.3,16-12.1,16-21.2C32,3.8,28.2,0,23.6,0z"/></svg>');
							
							$("#donate_main_container01").empty();
							$("#donate_main_container01").append('<h5>Payment succesful!</h5>');
							              
							
							//Music  Download Scripts/links   come here
                            // Download Scripts come here
							
							 var cartlist2 = shoppingCart.listCart();
		                     var cartlist3 = JSON.stringify(cartlist2);
                            // alert(cartlist3);
							
							var purchaseList = JSON.parse(cartlist3);
							//alert(purchaseList);
	                          
							 for (i in purchaseList) {
						 
						       var phoneNumber00 = $('#phone-number00').html();
		              
							 $("#donate_main_container01").append('<p style="margin-bottom:5px;"><a href="'+purchaseList[i].file_url+'" download="'+purchaseList[i].name+'" style="margin:6px;background-color:green;color:white;padding:5px;border-radius:4px;font-style:segoe ui light;text-decoration:none;font-size:1em;"><span style="color:;">'+purchaseList[i].name+'</span><span class="fontx fx-download" style="color:white;margin-right:7px;margin-left:7px;"></span></a></p>');
							   
							 }
		 
							$("#donate_main_container01").append('<div class="w3-col l12 m12 s12"><input type="" id="close-cart-btn" class="w3-btn" value="Close" style="background-color:rgba(0,0,0,0.1);border-radius:4px;margin-top:10px;height:35px;width:75px;cursor:pointer;color:red;font-family:sego ui light;"/></div>');
							
   
					         } else if(freelance.transaction_status == 'failed'){
								
              $("#donate_main_container01").empty();
							$("#donate_main_container01").append('<h5>Transaction failed! Please try again</h5>');
							$("#donate_main_container01").append('<div class="w3-col l12 m12 s12"><input type="" id="close-cart-btn" class="w3-btn" value="Ok" style="background-color:rgba(0,0,0,0.1);border-radius:4px;height:35px;width:75px;cursor:pointer;color:red;font-family:sego ui light;"/></div>');
							//$("#donate_main_container").append('<br/><div class="loader"></div><br/>');

							 }
 
							
							});
						  
						}); 
			 
					}else{
						
						
					}
				 

             }, 6000);
			

			
		 
		    //console.log(newdata.transactionReference);
		 
				  
		}); 	
		
		 
		}
		else
		{
		
		        //alert('We will reload the the page to process your order. After refreshing try to again.');
				 //location.reload();
               //  $('#cart').fadeIn('slow'); 
                  $('#main_cart_content00').empty();
                  $('#main_cart_content00').append('<p>Click the link below to refresh after clicking the page will reload and then begin the process again</p>');
                  $('#actions416').empty();
				          $('#actions416').append('<a href="" class="w3-col l12 m12 s12"><input type="" class="w3-btn" value="Refresh" style="text-decoration:none;background-color:rgba(0,0,0,0.1);border-radius:4px;height:35px;width:85px;cursor:pointer;color:red;font-family:sego ui light;"/></a>');
				 
				 
     				 
		}
		
		
	});
	
$(document).on('submit', '#card_money', function(event){
		event.preventDefault();
		event.stopPropagation();
		
		 alert(orderDetails);
		
		 var phone = $('#phone').val();
		 var userid = '001';
		 var fname = 'Ngenda';
		 var lname = 'Muliwana';
		 var email = 'ngendamuliwana@gmail.com';
		 
		 //alert(userid);
		 //alert(phone);
		 
		if(orderDetails != '')
		{
			 
		   datastring='userid='+userid+'&fname='+fname+'&lname='+lname+'&email='+email+'&orderDetails='+orderDetails;
		
              
	    $.ajax({
				 					
	        data:datastring,
			url: "payment-processing/cardPayment.php",
	        type: "POST"	
				
	    }).done (function(data) {
			  
              	var result = JSON.parse(data);
				
                 //alert(result);
                // alert(result.poststatus);
				   
		}); 	
		
		 
		}
		else
		{
		
		        alert('fill in your phone money number or cart items');
				   
		}
		
		
	});
	
